;...
;% Define parametric gradient wind (V) and vorticity (Z) profiles
;% using Holland (1980) bogus with core modified to quadratic.
rmrb = (rm/r)^b;
V = sqrt( b*dp/rho * exp(-rmrb) * rmrb + (0.5*f*r)^2 ) - 0.5*f*r;
Z = -f + sqrt( 4*b*dp/rho * exp(-rmrb) * rmrb + (f*r)^2 ) $
       * ( b*dp/rho * rmrb * (2 + b*(rmrb - 1)) * exp(-rmrb) + (f*r)^2 ) $
       / ( r * ( 4*b*dp/rho * exp(-rmrb) * rmrb + (f*r)^2 ) );
;
   E = exp(1) &$
   Vm = sqrt( b*dp/(rho*E) + (0.5*f*rm)^2 ) - 0.5*f*rm  &$
   dVm = -f/2 + ( E*(f^2)*rm*sqrt((4*b*dp/rho)/E + (f*rm)^2) )/ $
                ( 2*(4*b*dp/rho + E*(f*rm)^2) ) &$
   d2Vm = ( b*dp*(-4*b^3*dp/rho - (-2 + b^2)*E*(f*rm)^2) ) / $
          ( E*rho*sqrt((4*b*dp)/(E*rho) + (f*rm)^2) * $
            (4*b*dp*rm^2/rho + E*(f*rm^2)^2) )  &$
   aa = ( d2Vm/2 - ( dVm - Vm/rm )/rm ) / rm &$
   bb = ( d2Vm - 6*aa*rm ) / 2    &$
   cc = dVm - 3*aa*rm^2 - 2*bb*rm  &$
   icore= where(r lt rm) &$
   V(icore) = r(icore) * ( r(icore) * ( r(icore)*aa + bb ) + cc ) &$
   Z(icore) = r(icore) * ( r(icore) * 4*aa + 3*bb ) + 2*cc &$
   pm = pe - dp*(1 - exp(-1)) &$
   p=fltarr(61,61) &$
   p(icore) = pm + ( r(icore)^6 - rm^6 ) * (aa^2)/6 $
                 + ( r(icore)^5 - rm^5 ) * (2*aa*bb)/5  $
                 + ( r(icore)^4 - rm^4 ) * (aa*(2*cc+f)+bb^2)/4  $
                 + ( r(icore)^3 - rm^3 ) * (bb*(2*cc+f))/3  $
                 + ( r(icore)^2 - rm^2 ) * (cc*(cc+f))/2  &$

;
